<template>
    <div class="reform-pilot-containter flex">
        <div class="reform-top-item top-item-1">
            <div class="sub-title">所属领域</div>
            <!-- 向上移动-->
            <div
                :element-loading-background="loadingColor"
                v-loading="loading"
                id="reform-ray-chart"
            ></div>
        </div>
        <div class="reform-top-item top-item-2">
            <div class="sub-title">国家级改革试点台账</div>
            <div
                id="pie-chart-gjj"
                :element-loading-background="loadingColor"
                v-loading="loading"
            ></div>
            <div
                class="total"
                
            >
            <!-- @click="openSubDialog('pilotAccountCentreTotal')" -->
                累计部署<br />{{ countryAccount.total }}
            </div>
        </div>
        <div class="reform-top-item top-item-3">
            <div class="sub-title">市级改革试点台账</div>
            <div
                id="pie-chart-sj"
                :element-loading-background="loadingColor"
                v-loading="loading"
            ></div>
            <div
                class="total"
                
            >
            <!-- @click="openSubDialog('pilotAccountMunicipalTotal')" -->
                累计部署<br />{{ cityAccount.total }}
            </div>
        </div>
        <!-- <div class="reform-top-item top-item-3">
            <div class="reform-top-item-sub">
                <div class="sub-title">国家级改革试点台账</div>
                <div
                    class="reform-top-item-content flex-space-a"
                    :element-loading-background="loadingColor"
                    v-loading="loading"
                >
                    <div
                        @click="openSubDialog('pilotAccountCentreTotal')"
                        class="reform-block-full flex-center-column"
                    >
                        <div>
                            累计部署 <em>{{ countryAccount.total }}</em
                            >项
                        </div>
                    </div>
                    <div class="reform-block-branch flex-around-column">
                        <div
                            class="reform-block-branch-item"
                            v-for="item in countryAccount.subData"
                            :key="item.description"
                        >
                            {{ item.description }}<em>{{ item.commonCount }}</em
                            >项
                        </div>
                    </div>
                </div>
            </div>
            <div class="reform-top-item-sub">
                <div class="sub-title">市级改革试点台账</div>
                <div
                    class="reform-top-item-content flex-space-a"
                    :element-loading-background="loadingColor"
                    v-loading="loading"
                >
                    <div
                        @click="openSubDialog('pilotAccountMunicipalTotal')"
                        class="reform-block-full flex-center-column"
                    >
                        <div>
                            累计部署 <em>{{ cityAccount.total }}</em
                            >项
                        </div>
                    </div>
                    <div class="reform-block-branch flex-around-column">
                        <div
                            class="reform-block-branch-item"
                            v-for="item in cityAccount.subData"
                            :key="item.description"
                        >
                            {{ item.description }}<em>{{ item.commonCount }}</em
                            >项
                        </div>
                    </div>
                </div>
            </div> 
        </div>-->
        <EasyDialog
            v-model="showEasy"
            :top="dialogOption.top"
            :width="dialogOption.width"
            :title="dialogOption.dialogTitle"
        >
            <component
                v-bind:is="currentTabComponent"
                :tableOptions="tableOptions"
            ></component>
        </EasyDialog>
    </div>
</template>

<script>
import * as echarts from 'echarts'
import apiList from '@/api/bigScreen/districView.js'
import {Radar} from '@antv/g2plot'
import dialogConfig from '@/views/BigScreen/js/DistrictReformDialogConfig.js'
import dialogComponents from '@/views/BigScreen/js/dialog_components.js'
import EasyDialog from '@/views/BigScreen/components/easy-dialog/index.vue'
export default {
    name: 'reformPilot',
    components: {
        EasyDialog,
        ...dialogComponents,
    },
    data() {
        return {
            loadingColor: 'rgba(6, 46, 106, 0.4)',
            loading: false,
            currentTabComponent: '',
            tableOptions: null,
            dialogOption: {
                dialogTitle: '',
                width: '50%',
            },
            showEasy: false,
            // 雷达 所属领域
            rayChart2: null,
            rayChartOption2: null,
            // 对接时 max设置为值的1.2倍
            rayChartData2: [
                {description: '党建统领', commonCount: 0, type: '国家级'},
                {description: '党建统领', commonCount: 0, type: '市级'},
                {description: '经济发展', commonCount: 0, type: '国家级'},
                {description: '经济发展', commonCount: 0, type: '市级'},
                {description: '社会民生', commonCount: 0, type: '国家级'},
                {description: '社会民生', commonCount: 0, type: '市级'},
                {description: '文化建设', commonCount: 0, type: '国家级'},
                {description: '文化建设', commonCount: 0, type: '市级'},
                {description: '平安法治', commonCount: 0, type: '国家级'},
                {description: '平安法治', commonCount: 0, type: '市级'},
                {description: '民主法制', commonCount: 0, type: '国家级'},
                {description: '民主法制', commonCount: 0, type: '市级'},
            ],
            cityAccount: {
                total: 0,
                subData: [
                    {
                        value: 0,
                        name: '已验收',
                    },
                    {
                        value: 0,
                        name: '推进中',
                    },
                    // {
                    //     value: 0,
                    //     name: '未启动',
                    // },
                ],
            },
            countryAccount: {
                total: 0,
                subData: [
                    {
                        value: 0,
                        name: '已验收',
                    },
                    {
                        value: 0,
                        name: '推进中',
                    },
                    // {
                    //     value: 0,
                    //     name: '未启动',
                    // },
                ],
            },
            pieChart1: null,
            pieChart2: null,
            pieChart1Option: null,
            pieChart2Option: null,
        }
    },
    mounted() {
        this.loadData()
        // this.initPieChart1()
        // this.initPieChart2()
        this.$bus.$on('changeDate', () => {
            this.loadData()
        })
    },
    methods: {
        initPieChart1() {
            let chartDom = document.getElementById('pie-chart-gjj')
            this.pieChart1 = echarts.init(chartDom)
            this.pieChart1Option = {
                tooltip: {
                    trigger: 'item',
                    backgroundColor: 'rgba(6, 47, 107, 1)',
                    borderColor: 'rgba(2, 115, 233, 1)',
                    textStyle: {
                        color: '#fff',
                    },
                },
                legend: {
                    top: '2%',
                    left: 'center',
                    itemHeight: 16,
                    textStyle: {
                        color: '#B1E3FF',
                        fontSize: 18, //文字大小
                    },
                },
                series: [
                    {
                        name: '国家级改革试点项目',
                        type: 'pie',
                        radius: ['45%', '65%'],
                        top: 45,
                        emphasis: {
                            show: false,
                        },
                        label: {
                            textStyle: {
                                color: '#B1E3FF', // 改变标示文字的颜色
                                fontSize: 16, //文字大小
                            },
                            formatter: '{b} {c} \n\n',
                            padding: [0, -80],
                            alignTo: 'labelLine',
                        },
                        labelLine: {
                            //指示线样式设置
                            length: 20, //设置指示线的长度
                            length2: 80, //横线宽度
                            lineStyle: {
                                color: '#B1E3FF', // 设置标示线的颜色
                            },
                        },
                        data: this.countryAccount.subData,
                        // [
                        //     {value: 484, name: '已验收'},
                        //     {value: 580, name: '推进中'},
                        //     {value: 300, name: '未启动'},
                        // ],
                        color: ['#59c06c', '#026cdc', '#FFB51F'],
                    },
                ],
            }

            this.pieChart1Option &&
                this.pieChart1.setOption(this.pieChart1Option)
            window.addEventListener('resize', () => this.pieChart1.resize())
        },
        initPieChart2() {
            let chartDom = document.getElementById('pie-chart-sj')
            this.pieChart2 = echarts.init(chartDom)
            this.pieChart2Option = {
                tooltip: {
                    trigger: 'item',
                    backgroundColor: 'rgba(6, 47, 107, 1)',
                    borderColor: 'rgba(2, 115, 233, 1)',
                    textStyle: {
                        color: '#fff',
                    },
                },
                legend: {
                    top: '2%',
                    left: 'center',
                    itemHeight: 10,
                    textStyle: {
                        color: '#B1E3FF',
                        fontSize: 18, //文字大小
                    },
                },
                series: [
                    {
                        name: '市级改革试点项目',
                        type: 'pie',
                        radius: ['45%', '65%'],
                        top: 45,
                        emphasis: {
                            show: false,
                        },
                        label: {
                            textStyle: {
                                color: '#B1E3FF', // 改变标示文字的颜色
                                fontSize: 16, //文字大小
                            },
                            formatter: '{b} {c} \n\n',
                            padding: [0, -80],
                            alignTo: 'labelLine',
                        },
                        labelLine: {
                            //指示线样式设置
                            length: 20, //设置指示线的长度
                            length2: 80, //横线宽度
                            lineStyle: {
                                color: '#B1E3FF', // 设置标示线的颜色
                            },
                        },
                        data: this.cityAccount.subData,
                        // [
                        //     {value: 484, name: '已验收'},
                        //     {value: 580, name: '推进中'},
                        //     {value: 300, name: '未启动'},
                        // ],
                        color: ['#59c06c', '#026cdc', '#FFB51F'],
                    },
                ],
            }

            this.pieChart2Option &&
                this.pieChart2.setOption(this.pieChart2Option)
            window.addEventListener('resize', () => this.pieChart2.resize())
        },
        loadData() {
            this.loading = true
            let searchDate = sessionStorage.getItem('searchDate')
            searchDate = JSON.parse(searchDate)
            let data = this.qs.stringify({
                year: searchDate.year,
                quarter: searchDate.quarter,
            })
            apiList.getPilotLedger(data, (res) => {
                if (res && res.value) {
                    let data = res.value
                    data.forEach((item) => {
                        if (item.description == '市级') {
                            this.cityAccount.total = item.commonCount
                            item.subData.ledger.forEach((item) => {
                                this.cityAccount.subData.forEach((data) => {
                                    if (item.description == data.name) {
                                        data.value = item.commonCount || 0
                                    }
                                })
                            })
                            item.subData.field.forEach((item) => {
                                this.rayChartData2.forEach((data) => {
                                    if (
                                        item.description == data.description &&
                                        data.type == '市级'
                                    ) {
                                        data.commonCount = item.commonCount || 0
                                    }
                                })
                            })
                        } else {
                            this.countryAccount.total = item.commonCount
                            item.subData.ledger.forEach((item) => {
                                this.countryAccount.subData.forEach((data) => {
                                    if (item.description == data.name) {
                                        data.value = item.commonCount || 0
                                    }
                                })
                            })
                            item.subData.field.forEach((item) => {
                                this.rayChartData2.forEach((data) => {
                                    if (
                                        item.description == data.description &&
                                        data.type == '国家级'
                                    ) {
                                        data.commonCount = item.commonCount || 0
                                    }
                                })
                            })
                        }
                    })
                    if (this.pieChart1 == null) {
                        this.initRayChart2()
                        this.initPieChart1()
                        this.initPieChart2()
                    } else {
                        this.pieChart2.setOption(this.pieChart2Option)
                        this.pieChart1.setOption(this.pieChart1Option)
                        this.rayChart2.update()
                    }
                    console.log(this.rayChartData2)
                    this.loading = false
                }
            })
        },
        openSubDialog(type) {
            this.currentTabComponent = dialogConfig.dialogOption[type]
                .componentName
                ? dialogConfig.dialogOption[type].componentName
                : type // 动态组件名称
            this.tableOptions = dialogConfig.dialogOption[type].dataOptions //table的查询参数
            this.dialogOption = dialogConfig.dialogOption[type].option //弹窗配置参数
            this.showEasy = true
        },
        initRayChart2() {
            this.rayChart2 = new Radar('reform-ray-chart', {
                data: this.rayChartData2,
                radius: 100,
                colorField: 'type', // 部分图表使用 seriesField
                color: ['#FFB51F', '#82D7FF'],
                xField: 'description',
                yField: 'commonCount',
                seriesField: 'type',
                tooltip: {
                    shared: true,
                    showCrosshairs: true,
                    domStyles: {
                        'g2-tooltip': {
                            background: 'rgba(6, 47, 107, 1)',
                            borderColor: 'rgba(2, 115, 233, 1)',
                            borderWidth: 0.5,
                            borderStyle: 'solid',
                            boxShadow: null,
                            color: '#fff',
                        },
                        'g2-tooltip-title': {
                            fontSize: '18px',
                        },
                    },
                },
                legend: {
                    position: 'top',
                    itemName: {
                        style: {
                            fill: '#B1E3FF',
                            fontSize: 18,
                        },
                    },
                },
                meta: {
                    value: {
                        alias: '试点数量',
                    },
                },
                xAxis: {
                    line: null,
                    tickLine: null,
                    label: {
                        style: {
                            fill: '#D7F1FF',
                            fontSize: 18,
                        },
                        offset: 3,
                    },
                    grid: {
                        line: {
                            style: {
                                stroke: 'rgba(154,199,220, 0.2)',
                            },
                        },
                    },
                },
                yAxis: {
                    line: null,
                    tickLine: null,
                    label: false,
                    label: false,
                    grid: {
                        line: {
                            type: 'line',
                            style: {
                                stroke: 'rgba(154,199,220, 0.2)',
                                fill: 'rgba(84,142,255,0.1)',
                            },
                        },
                    },
                },
                // 开启面积
                area: {},
                point: null,
            })
            this.rayChart2.render()
        },
    },
}
</script>

<style lang="scss" scoped>
@import '@/assets/css/big-screen.scss';
.reform-pilot-containter{
    width: 100%;
    height: 100%;
    box-sizing: border-box;
    padding-top: 10px;
    .total{
        position: absolute;
        left: 50%;
        top: 245px;
        transform: translate(-50%,0);
        text-align: center;
        color: #FFFFFF;
        font-size: 18px;
        cursor: pointer;
    }
    .sub-title{
        margin-bottom: 30px;
        font-size: 20px;
    }
    .sub-title::before{
        left: 30%!important;
    }
    .sub-title::after{
        right: 30%!important;
    }
    .top-item-2 .sub-title::before {
        left: 20% !important;
    }
    .top-item-2 .sub-title::after {
        right: 20% !important;
    }
    .top-item-3 .sub-title::before {
        left: 24% !important;
    }
    .top-item-3 .sub-title::after {
        right: 24% !important;
    }
    #pie-chart-gjj{
        height: 400px;
        width: 100%;
    }
    #pie-chart-sj{
        height: 400px;
        width: 100%;
    }
    #reform-ray-chart{
        height: 400px;
        width: 100%;
    }
    .reform-top-item{
        width: 33%;
        height: 80%;
        position: relative;
    }
    
    .reform-top-item-sub{
        width: 340px;
        height: 200px;
    }
    .reform-top-item-sub:nth-of-type(2){
        margin-top: 3%;
    }
    .reform-top-item-content{
        width: 100%;
        height: 450px;
    }
    .reform-block-full{
        cursor: pointer;
        width: 140px;
        height: 64px;
        text-align: center;
        border: 1px solid #0273E9;
        background: rgba(#0273E9, 0.3);
        font-size: 14px;
        font-family: SimHei;
        font-weight: 400;
        color: #D7F1FF;
        em{
            font-size: 16px;
            font-family: SimHei;
            font-weight: bold;
            color: #FFFFFF;
            font-style: normal;
            margin-right: 4px;
        }
    }
    .reform-block-branch{
        height: 64px;
        position: relative;
    }
    .reform-block-branch::after{
        content: '';
        position:absolute;
        width: 36px;
        height: 36px;
        right: 100%;
        top: 50%;
        transform: translateY(-50%);
        background: url('~@/assets/img/bigScreen/img_iindu_jt@2x.png') no-repeat center / 100% 100%;
    }
    .reform-block-branch-item{
        // cursor: pointer;
        width: 130px;
        text-align: center;
        padding: 5px 16px;
        font-size: 13px;
        font-family: SimHei;
        font-weight: 400;
        color: #D7F1FF;
        border: 1px dashed #0273E9;
        background: rgba(#0273E9, 0.3);
        em{
            font-size: 16px;
            font-family: SimHei;
            font-weight: bold;
            color: #FFFFFF;
            font-style: normal;
            margin:0 4px;
        }
    }
}
</style>